<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form class="ls-form" xmlns="http://www.w3.org/1999/html">

  <div class="form-group">
    <label
      for="layersList"
      [innerText]="messages.LINK_LAYER_">
    </label>

    <div class="d-flex flex-row">
      <ng-select
        id="layersList"
        class="flex-grow-1"
        [items]="filteredLayersList"
        [(ngModel)]="selectedLayer"
        [notFoundText]="commonMessages.NOT_FOUND"
        [clearAllText]="commonMessages.CLEAR"
        [clearable]="true"
        [ngModelOptions]="{standalone: true}">

        <ng-template let-item="item" ng-option-tmp>
          {{ item.name | namePipe }}
        </ng-template>

        <ng-template let-item="item" ng-label-tmp>
          <span class="ng-value-label" [innerText]="item.name"></span>
        </ng-template>

      </ng-select>

      <button
        type="button"
        class="btn btn-sm btn-outline-primary ms-2"
        [disabled]="!selectedLayer"
        (click)="onAddLayerButtonClicked()">
        <fa-icon [icon]="linkIcon"></fa-icon>
        {{ commonMessages.LINK }}
      </button>
    </div>
  </div>

  <div class="form-group">

    <label
      id="linkedLayersListLabel"
      [innerText]="messages.LINKED_LAYERS_">
    </label>

    <table
      aria-labelledby="linkedLayersListLabel"
      class="mt-2 bg-white table table-striped table-borderless border">
      <thead class="border">
        <tr>
          <th
            scope="col"
            class="th-sm"
            [innerText]="commonMessages.NAME">
          </th>
          <th
            scope="col"
            class="th-sm col-associations-fixed-size"
            [innerText]="messages.ASSOCIATION_TYPE">
          </th>
          <th
            scope="col"
            class="th-sm col-buttons-fixed-size"
            [innerText]="commonMessages.UNLINK">
          </th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let subtypeLayer of subtype.subtypeLayers">
          <td [innerText]="subtypeLayer.layer.name | namePipe"></td>
          <td>
            <ng-select
              class="flex-grow-1"
              [items]="subtypeLayerAssociationEnum | keyvalue"
              bindValue="value"
              [(ngModel)]="subtypeLayer.association"
              [searchable]="false"
              [clearable]="false"
              [ngModelOptions]="{standalone: true}">

              <ng-template let-item="item" ng-option-tmp>
                <span class="ng-value-label" [innerText]="item.value | subtypeLayerAssociationName"></span>
              </ng-template>

              <ng-template let-item="item" ng-label-tmp>
                <span class="ng-value-label" [innerText]="item.value | subtypeLayerAssociationName"></span>
              </ng-template>
            </ng-select>
          </td>
          <td>
            <button
              type="button"
              class="btn btn-sm btn-outline-danger me-2"
              (click)="onUnlinkButtonClicked(subtypeLayer)">
              <fa-icon [icon]="unlinkIcon"></fa-icon>
            </button>
          </td>
        </tr>
      </tbody>
      <tbody
        app-list-loader
        [emptyMessage]="commonMessages.EMPTY_LAYER_LIST"
        [data]="subtype.subtypeLayers"
        [loading]="loading"
        [colspan]="3">
      </tbody>
    </table>

    <ngb-pagination
      class="d-flex justify-content-end"
      size="sm"
      [collectionSize]="total"
      [pageSize]="getPageSize(pageSizeIndex)"
      [(page)]="page"
      [maxSize]="5"
      [rotate]="true"
      [boundaryLinks]="false"
      [directionLinks]="false">
    </ngb-pagination>
  </div>

</form>
